# a panda3d community copy.
# Panda3d Library: these sentences loads defined functions from python scripts
# under the panda3d library providing features and functions from panda3d.
# this loads the visual functions from panda3d into python.
from direct.showbase.ShowBase import ShowBase
# this loads the lighting functions from panda3d into python.
from panda3d.core import Filename, AmbientLight, DirectionalLight
# this loads camera funcations from panda3d into python
from panda3d.core import PandaNode, NodePath, Camera, TextNode
# this loads text functions from panda3d into python.
from direct.gui.OnscreenText import OnscreenText
# this loads the panda3d task manager into pyrhon.
from direct.task import Task
# this loads the animation funcations from panda3d into python.
from direct.actor.Actor import Actor
# ???
from direct.showbase.DirectObject import DirectObject
# ???
from direct.interval.IntervalGlobal import Sequence, Func, Wait
# this loads the collision detection logic from panda3d.
from panda3d.core import CollisionTraverser, CollisionHandlerPusher, CollisionHandlerEvent
from panda3d.core import CollisionNode, CollisionSphere
from panda3d.core import Point3
#import direct.directbase.DirectStart
# this loads in other functions not included in this script.
import random
import sys
import os
import math

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Game
# - - -
# Load List: a filepath to a model is assigned to a interger (defined model)
scene1 = "Room/scenetest_pro.egg"
actor1 = "Actor/charatest.egg"
# - - -
# Movment Varibles: used for features to track movement.
norpar = 0.0
nwpar = 0.0
wespar = 0.0
swpar = 0.0
soupar = 0.0
separ = 0.0
easpar = 0.0
nepar = 0.0
facing = 0.0
forward = False
vel = 0
# jump variables
jmpstm = 30
jmpdel = 0
# falling variables
prepos = 0.0
pospos = 0.0
falling = False
# marching variables
surX1 = 0
surY1 = 0
surZ1 = 0
surX2 = 0
surY2 = 0
surZ2 = 0
land = False
collided = False
step = True
# debugging variables
debug = True
room = 0
# - - -
# Game System: controls all the logic for the game.
class gamesys(ShowBase):

    def __init__(self):
        ShowBase.__init__(self)
        
# - Model (Visual) Functions -        
# Loads the model defined as the background environment, and reparents the model to
# render, finally sets the postion of the rendered background.
        self.scene = self.loader.loadModel(scene1)
        self.scene.reparentTo(self.render)
        self.scene.setPos(0, 0, 0)

# Loads the model defined as the player, then loads it's animation in the same
# line, it is then reparneted to render, finaly the animation is set to loop.
        self.pactor = Actor(actor1, {"Walk": "Actor/charatest-Walk"})
        self.pactor.reparentTo(self.render) 
        self.pactor.loop("Walk")
        self.srtpos = self.scene.find("**/start").getPos()
        self.pactor.setPos(self.srtpos + (0.0, 0.0, 6.3))
                                       
# - Camera Functions -
# Disable the camera (default) trackball controls, and allows the camera to be
# moved around the player.
        self.disableMouse()
        self.camera.setPos(self.pactor.getX(), self.pactor.getY() + 10, 6)
        
# this creates a target for the cmaera to focus on.
        self.camtarget = NodePath(PandaNode("ctarget"))
        self.camtarget.reparentTo(self.pactor)
        self.camtarget.setZ(2.0)

# this determines the game's lighting
        ambientLight = AmbientLight("ambientLight")
        ambientLight.setColor((.3, .3, .3, 1))
        directionalLight = DirectionalLight("directionalLIght")
        directionalLight.setDirection((-5, -5, -5))
        directionalLight.setColor((1, 1, 1, 1))
        directionalLight.setSpecularColor((1, 1, 1, 1))
        render.setLight(render.attachNewNode(ambientLight))
        render.setLight(render.attachNewNode(directionalLight))

# - Control (Keyboard) Functions -
        self.keyMap = {"north": 0, "east": 0, "south": 0, "west": 0, "ishop": 0, "zoomin": 0, "zoomout": 0, "cambob": 0, "camweave": 0}

# keys when held down.       
        self.accept("arrow_up", self.satKey, ["north", True])
        self.accept("arrow_down", self.satKey, ["south", True])
        self.accept("arrow_left", self.satKey, ["west", True])
        self.accept("arrow_right", self.satKey, ["east", True])
        self.accept("j", self.satKey, ["ishop", True])
        self.accept("a", self.satKey, ["cambob", True])
        self.accept("d", self.satKey, ["camweave", True])
        self.accept("w", self.satKey, ["zoomin", True])
        self.accept("x", self.satKey, ["zoomout", True])        

# keys when released.        
        self.accept("arrow_up-up", self.satKey, ["north", False])
        self.accept("arrow_down-up", self.satKey, ["south", False])
        self.accept("arrow_left-up", self.satKey, ["west", False])
        self.accept("arrow_right-up", self.satKey, ["east", False])
        self.accept("j-up", self.satKey, ["ishop", False])
        self.accept("a-up", self.satKey, ["cambob", False])
        self.accept("d-up", self.satKey, ["camweave", False])
        self.accept("w-up", self.satKey, ["zoomin", False])
        self.accept("x-up", self.satKey, ["zoomout", False])

# these plays out whatever is defined (def) every frame, in this case the
# the movement functions.       
        self.taskMgr.add(self.move, "moveTask")

# - Collision Functions -

# the collision traverser scans everything for stuff (handlers) constintly so
# that when the time comes when something meets another thing, the traverser
# already knows and can return a value based on the handlers assigned to those
# somethings.
# this  creates delcares a self variable as a Collision Handler, then adds
# logic under it. there is also a thershold limit of 5 models up to 6,400 tris
# each and a scene up to 8,000 tris on screen at a time (7th gen game).
# this handler is for the floor, walls, and celing.                                       
        base.cTrav = CollisionTraverser()
        pusher = CollisionHandlerPusher()
# this below records the prevous postion just in case reverting        
        base.cTrav.setRespectPrevTransform(True)

# Create a collsion node this object (the player), models are supposed to have
# them written in using blender's logic editor, where they are loaded with said
# silently and invisalbe, but in cases of living objects a collision sphere is
# created for them like below, this attaches a new collsion node (model) to
# the player's model which is "model piece (blender)" named in green.
        self.actor1cn = self.pactor.attachNewNode(CollisionNode('player'))
# defines the attached above collison model as a collision sphere.
        self.actor1cn.node().addSolid(CollisionSphere(0, 0, 0.3, 0.3))
# this below adds a collider to the traverser system using the stated object
# (which is the player's sphere) as the tool for that added collider making
# the said object a "From" object and eveyhting else a "Into" object.
        base.cTrav.addCollider(self.actor1cn, pusher)
        pusher.addCollider(self.actor1cn, self.pactor)

# this defines how two objects collide (collision's conditions between two
# objects).        
        pusher.addAgainPattern('%fn-again-%in')
        pusher.addOutPattern('%fn-out-%in')
# a collsion conformation map
        self.touMap = {"colX": 0, "colY": 0, "colZ": 0}
# this defines what 2 objects (model pieces) do under said above collision's
# condiitons (above the collision map) when those two objects do the collision
# (all defined in green) the said effect of that collision is a defined function
# that is played out, the solidness of the game is always assigned to t0.
#        self.accept("player-again-plane", self.touch, ["collide", True])
#        self.accept("player-out-plane", self.touch, ["collide", False])
        self.accept("player-again-cube_hori ori", self.touch, ["colX", False])

# t1 object: bouncy box.        
#        self.accept("player-again-cube_hori ori", self.touch, ["feet", True],["face", True], ["back", True], ["lefth", True], ["righth", True], ["head", True])
#        self.accept("player-out-cube_hori ori", self.touch, ["feet", False],["face", False], ["back", False], ["lefth", False], ["righth", False], ["head", False])

# tasks that untilizes collsions.                                       
        self.taskMgr.add(self.fall, "fallTask")

# - Debugging -
        if debug:
# this creates a node for the debug line which is called on later
           self.debugline1 = TextNode("line1")              
# this adds the node to the 2d plane.        
           dgline1 = aspect2d.attachNewNode(self.debugline1)
# this sets the size and position of the text.        
           dgline1.setScale(0.05)
           dgline1.setPos(-1.3, 0.00, 0.9)

# line 2.
           self.debugline2 = TextNode("line2")                     
           dgline2 = aspect2d.attachNewNode(self.debugline2)        
           dgline2.setScale(0.05)
           dgline2.setPos(-1.3, 0.00, 0.8)

        
# line 3.
           self.debugline3 = TextNode("line3")                    
           dgline3 = aspect2d.attachNewNode(self.debugline3)        
           dgline3.setScale(0.05)
           dgline3.setPos(-1.3, 0.00, 0.7)

# line 4.
           self.debugline4 = TextNode("line4")                     
           dgline4 = aspect2d.attachNewNode(self.debugline4)        
           dgline4.setScale(0.05)
           dgline4.setPos(-1.3, 0.00, 0.6)

# line 5.
           self.debugline5 = TextNode("line5")                    
           dgline5 = aspect2d.attachNewNode(self.debugline5)        
           dgline5.setScale(0.05)
           dgline5.setPos(-1.3, 0.00, 0.5)
        
# line 6.
           self.debugline6 = TextNode("line6")                    
           dgline6 = aspect2d.attachNewNode(self.debugline6)        
           dgline6.setScale(0.05)
           dgline6.setPos(-1.3, 0.00, 0.4)

# this shows all the collisions (debugging)        
           base.cTrav.showCollisions(render)
# Set the object's collison node to render as visible (debugging).
           self.actor1cn.show()

# this task updates the text with changing varibles
           self.taskMgr.add(self.debugupdate, "debugTask")

# defined functions for this class - - - - - - - - - - - - - - - - - - - - - -
    def satKey(self, key, value):
        self.keyMap[key] = value

    def touch(self, tou, col, value):
        self.touMap[tou] = value.getSurfaceNormal(self.actor1cn)
        

    def fall(self, task):
        dt = globalClock.getDt()
        self.pactor.setZ(self.pactor, -5 * dt)

        return Task.cont
        
        
    def move(self, task):
        dt = globalClock.getDt()
        global jmpdel
        global facing
        global vel
        global jmpstm
        global falling
        global forward
        global premvt
        global posmvt
        global norpar
        global nwpar
        global wespar
        global swpar
        global soupar
        global separ
        global easpar
        global nepar
            
# Camera Controls (for move) - - -     
# self.obejct within self.set object is the self.get for itself.
# standard roaming mode, as normal, tilted as zoomout

        if self.keyMap["cambob"]:            
             self.camera.setX(self.camera, -20 * dt)
        if self.keyMap["camweave"]:
             self.camera.setX(self.camera, +20 * dt)

        if self.keyMap["zoomin"]:
            if self.camera.getZ() > 2:
              self.camera.setZ(self.camera, -0.2)
        if self.keyMap["zoomout"]:
            if self.camera.getZ() < 16:
              self.camera.setZ(self.camera, +0.2)

            

# camvec is player's postion minus the camera's position or essentally the
# diffrence of the player's postion plus settting Z to 0, meaning only the
# X and Y diffrences or horizonal and verticals.
        camvec = self.pactor.getPos() - self.camera.getPos()
        camvec.setZ(0)
# camdist is the diaginal length between camvec's X and Y postions as a the
# missing trinagle piece.
        camdist = camvec.length()
# normalizes camvec's vector? (true if nomralize, false if zero-lentgh vector)       
        camvec.normalize()
        if camdist > 10.0:
             self.camera.setPos(self.camera.getPos() + camvec * (camdist -10))
             camdist = 10.0
        if camdist < 5.0:
             self.camera.setPos(self.camera.getPos() - camvec * (5 - camdist))
             camdist = 5.0
             

        if self.camera.getZ() < self.pactor.getZ() + 2.0:
            self.camera.setZ(self.pactor.getZ() + 2.0)

        self.camera.lookAt(self.camtarget)
        norpar = self.camera.getH() - 180.0
        nwpar = self.camera.getH() - 135.0
        wespar = self.camera.getH() - 90.0
        swpar = self.camera.getH() - 45.0
        soupar = self.camera.getH()
        separ = self.camera.getH() + 45.0
        easpar = self.camera.getH() + 90.0
        nepar = self.camera.getH() + 135.0
# 180 the normal for camera getH.

# Player Controls (for move) - - -
# this makes the player jump, by declaring the state of jumping as true and
# increasing the Z co-ord, when let go, the fall (gravity) function will kick
# in causing the player to fall back into place.
        if self.keyMap["ishop"]:
            if jmpstm is not 30:
                self.pactor.setZ(self.pactor, +8 * dt)
                jmpstm += 1

            else:
                if jmpdel is 5:               
                    if not falling:
                       jmpstm = 0
                       jmpdel = 0
                else:
                    jmpdel += 1
        else:
            jmpstm = 30
            jmpdel = 0

                
# when a player presses a buttion, the driection of that buttion becomes true
# as long as the press happens, a press results in the player's speed and
# movement going foward.


        if self.keyMap["north"] or self.keyMap["east"] or self.keyMap["south"] or self.keyMap["west"]:
           forward = True
           vel += 1
           self.pactor.setY(self.pactor, -5 * dt)

 # depedning on what direction is true (pessed/as long as pressed)  it asks if
# the player's speed is at a cetain point it tabs you to the target point, if
# not and not in the target point, it asks your are facing farthest or closest
# points each 45 degrees a part rightward of the target point, if so it tabs you
# to the target point if not, it asks if your facing farthest or closest points
# each 45 degrees apart leftward of the target point if so it tabs you to the
# target point. if not that, it asks if you are facing the points other then
# stated, if so, it cuts the player's speed to 0 forboding for the first "if"
# to come true. rotational map for H is below.
# (Plus +: Conter Clockwise)                (Minus -: Clockwise)  
#                      45.0      0.0     315.0
#                      90.0  <    ^    > 270.0
#                      135.0      v      225.0
#                               180.0

           if self.keyMap["north"]:
              if vel < 120:
                  facing = norpar
                  self.pactor.setH(facing)
              else:
                  facing = norpar
                  self.pactor.setH(facing)

                         
           if self.keyMap["west"]:
              if vel < 120:
                    facing = wespar                    
                    self.pactor.setH(facing)
              else:
                    facing = wespar
                    self.pactor.setH(facing)

           if self.keyMap["south"]:
              if vel < 120:
                    facing = soupar
                    self.pactor.setH(facing)
              else:
                    facing = soupar
                    self.pactor.setH(facing)                       
                         
           if self.keyMap["east"]:
              if vel < 120:
                    facing = easpar
                    self.pactor.setH(facing)
              else:      
                    facing = easpar
                    self.pactor.setH(facing)

           if self.keyMap["north"] and self.keyMap["east"]:
              if vel < 120:
                    facing = nepar
                    self.pactor.setH(facing)
              else:
                    facing = nepar
                    self.pactor.setH(facing)

           if self.keyMap["north"] and self.keyMap["west"]:
              if vel < 120:
                    facing = nwpar
                    self.pactor.setH(facing)
              else:
                    facing = nwpar
                    self.pactor.setH(facing)

           if self.keyMap["south"] and self.keyMap["east"]:
              if vel < 120:
                    facing = separ
                    self.pactor.setH(facing)
              else:
                    facing = separ
                    self.pactor.setH(facing)

           if self.keyMap["south"] and self.keyMap["west"]:
              if vel < 120:
                    facing = swpar
                    self.pactor.setH(facing)
              else:      
                    facing = swpar
                    self.pactor.setH(facing)
          

        else:
            forward = False
            if vel > 0:
              vel -= 1
              
        return Task.cont

    def collision(self, task):
        global surX1
        global surY1
        global surZ1
        global surX2
        global surY2
        global surZ2
        global step
        global land
        global collided
        if step:
            surX1, surY1, surZ1 = self.touMap["collide"]
            step = False
            if surZ1 is surZ2:
                land = False
                if surX1 is surX2 and surY1 is surY2:
                    collided = False
                else:
                    collided = True
            else:        
                land = True
                if surX1 is surX2 and surY1 is surY2:
                    collided = False
                else:
                    collided = True
     
        else:
            surX2, surY2, surZ2 = self.touMap["collide"]
            step = True
            if surZ1 is surZ2:
                land = False
                if surX1 is surX2 and surY1 is surY2:
                    collided = False
                else:
                    collided = True
            else:        
                land = True
                if surX1 is surX2 and surY1 is surY2:
                    collided = False
                else:
                    collided = True
# want to add orignal fall algoryth for falling again to determine unevean
# terrain

        return Task.cont

# a task that if you fall under a cetain limit, the you lose a life and restart
# the level, the limit are global variables set in the level script itself.
#    def outbound(self, task):
#        if self.pactor.getZ() < dwnzbound or self.pactor.getZ() > upzbound:
#            self.pactor.setPos(0.0, 0.0, 6.3)

#        if self.pactor.getY() < souybound or self.pactor.getY() > norybound:
#            self.pactor.setPos(0.0, 0.0, 6.3)

#        if self.pactor.getX() < easxbound or self.pactor.getX() > wesxbound:
#            self.pactor.setPos(0.0, 0.0, 6.3)        
    
# - Debugging Functions -
# The actual text functions for the debug list.

    def debugupdate(self, task):
        global jmpstm
        global surX1
        global surY1
        global surZ1
        global surX2
        surX1 = self.touMap["colX"]


        
        line1 = "- DEBUG DISPLAY-"
        line2 = "JUMP STAMINA:" + str(jmpstm) 
        line3 = "FALLING:" + str(surX1)
        line4 = "COLLISION PRE:" + str(surY1)
        line5 = "COLLISION:" + str(surZ1)
        line6 = "COLLISION POS:" + str(surX2)

# these set the text into each of the created nodes listed after "self". 
        self.debugline1.setText(line1)
        self.debugline2.setText(line2)
        self.debugline3.setText(line3)
        self.debugline4.setText(line4)
        self.debugline5.setText(line5)
        self.debugline6.setText(line6) 
        
        return Task.cont
        
#this calls the preconstructed loop from panda3d engine instead of wrtting one.
app = gamesys ()
app.run()

# setP(X.X) = to tilt the model, setH(X.X) = rotates the model, setR(X.X) =
# pans the model in a pi (circle) degree angle.
# activate panda's placer mode
# def place (self):
#           base.startDirect(fWantTk = 1)
#           from direct.tkpanels import Placer
#           return Placer.place(self)
#------------------------------------------------------------------------------
# Python is basically using a calculator but you can label the numbers with a
# name, a number labeled under a name is called a “Integer”, now from the basic
# calculator commands there are additional ones that use names and other symbols
# for more manipulation, see command list below for their effects, a command can
# also be labeled just like a number, a command under a label is called a
# “Variable”, to label a number or command, you type in anything but a number
# alone, first, or a command name, then after that, a equal (=), then the number
# or command.

# Command List- - - - -

# = (equal sign): it does not do what it would do on a calculator, instead,
# whatever is after this becomes that of whatever is before this, if a number
# becomes a name, it is a integer, if a non number became a name, it is a
# variable,names cannot start with numbers but can end with numbers.

# + (Plus): addition with numbers labeled or not, but when dealing with commands
# label or not, it combines those commands involved, all each needing their own
# plus.

# - (Minus): subtraction with numbers labeled or not.

# * (Star, Multiply): does what the “X” on a calculator does, multiplication
# with numbers labeled or not.

# / (Slash, Division): does what the “Straight Percent Symbol” does on a
# calculator, division with numbers labeled or not.

# % (percent, modulus): it does not do what the percent would do on a calculator
# instead, it gives the difference from the division of a uneven division of
# numbers.

# print(): does what the equal (=) on a calculator does, and that is inject the
# “Result” of whatever is within the parentheses after this word into the
# standard output which is by default the console or screen (window).
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# script written by J.N. Pickee of the panda3d forums.
